#include <stddef.h>
#include <stdio.h>
#include <sys/utsname.h>

#include "Config.h"
#include "Converge.h"
#include "VM.h"
#include "Memory.h"
#include "Object.h"
#include "Builtins/Func.h"
#include "Builtins/String.h"
#include "Builtins/List.h"

#include "Builtins.h"



void Con_Mod_Builtins_init(Con_VM* vm)
{
	Con_Object_set_slot(vm, vm->continuation->module->module_val, "Class", vm->builtins[CON_BUILTIN_CLASS_CLASS]);
	Con_Object_set_slot(vm, vm->continuation->module->module_val, "Object", vm->builtins[CON_BUILTIN_OBJECT_CLASS]);
	Con_Object_set_slot(vm, vm->continuation->module->module_val, "Int", vm->builtins[CON_BUILTIN_INT_CLASS]);
	Con_Object_set_slot(vm, vm->continuation->module->module_val, "String", vm->builtins[CON_BUILTIN_STRING_CLASS]);
	Con_Object_set_slot(vm, vm->continuation->module->module_val, "List", vm->builtins[CON_BUILTIN_LIST_CLASS]);
	Con_Object_set_slot(vm, vm->continuation->module->module_val, "Dict", vm->builtins[CON_BUILTIN_DICT_CLASS]);
	Con_Object_set_slot(vm, vm->continuation->module->module_val, "Func", vm->builtins[CON_BUILTIN_FUNC_CLASS]);
	Con_Object_set_slot(vm, vm->continuation->module->module_val, "Func_Binding", vm->builtins[CON_BUILTIN_FUNC_BINDING_CLASS]);
	Con_Object_set_slot(vm, vm->continuation->module->module_val, "Module", vm->builtins[CON_BUILTIN_MODULE_CLASS]);
	Con_Object_set_slot(vm, vm->continuation->module->module_val, "Null", vm->builtins[CON_BUILTIN_NULL_CLASS]);
	Con_Object_set_slot(vm, vm->continuation->module->module_val, "Set", vm->builtins[CON_BUILTIN_SET_CLASS]);

	Con_VM_con_stack_push_value(vm, vm->continuation, vm->builtins[CON_BUILTIN_NULL_VAL]);
	Con_VM_return(vm);
}
