#include <stddef.h>
#include <stdio.h>
#include <stdlib.h>

#include "Config.h"
#include "Converge.h"
#include "VM.h"
#include "Memory.h"
#include "Object.h"
#include "Builtins/Func.h"
#include "Builtins/String.h"
#include "Builtins/List.h"
#include "Builtins/Int.h"

#include "Processes.h"




void Con_Mod_Processes_command_func(Con_VM* vm);




void Con_Mod_Processes_init(Con_VM* vm)
{
	Con_Value command_func;

	command_func = Con_Func_new(vm, false, (Con_PC) (C_Function) Con_Mod_Processes_command_func, PC_TYPE_C_FUNCTION, Con_String_new_c_str(vm, "command"), 0, NULL, vm->continuation->module);
	Con_Object_set_slot(vm, vm->continuation->module->module_val, "command", command_func);

	Con_VM_con_stack_push_value(vm, vm->continuation, vm->builtins[CON_BUILTIN_NULL_VAL]);
	Con_VM_return(vm);
}



void Con_Mod_Processes_command_func(Con_VM* vm)
{
	Con_Value command;

	Con_VM_decode_args(vm, "s", &command);

	Con_VM_con_stack_push_value(vm, vm->continuation, Con_Int_new(system(((Con_String_Object*) command.datum.object)->str)));
	Con_VM_return(vm);
}
